/*
    rc Task
    
*/

/* Includes ----------------------------------------------------------------- */
#include "task/user_task.h"
/* USER INCLUDE BEGIN */
#include "device/lightbridge2.h"
#include "component/lightbridge2_cmd.h"
/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
/* USER STRUCT BEGIN */
 uint8_t cmd_buffer[DEVICE_LIGHTBRIDGE2_FRAME_LEN];
 DEVICE_LIGHTBRIDGE2_t lightbridge2;
 COMP_LIGHTBRIDGE2_CMD_t rc_cmd;
/* USER STRUCT END */

/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */
void Task_rc(void *argument) {
  (void)argument; /* 未使用argument，消除警告 */

  
  /* 计算任务运行到指定频率需要等待的tick数 */
  const uint32_t delay_tick = osKernelGetTickFreq() / RC_FREQ;

  osDelay(RC_INIT_DELAY); /* 延时一段时间再开启任务 */

  uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
  /* USER CODE INIT BEGIN */

  /* USER CODE INIT END */
  
  while (1) {
    tick += delay_tick; /* 计算下一个唤醒时刻 */
    /* USER CODE BEGIN */
    if (DEVICE_LIGHTBRIDGE2_WaitDmaCplt(10)) {
        DEVICE_LIGHTBRIDGE2_ParseRaw(cmd_buffer, &lightbridge2);//底层
		    COMP_LIGHTBRIDGE2_CMD_ParseRc(&lightbridge2, &rc_cmd);//驱动——命令
        DEVICE_LIGHTBRIDGE2_StartDmaRecv(cmd_buffer);
    }
	
    osMessageQueuePut(task_runtime.msgq.cmd.rc, &lightbridge2, 0, 0);
    /* USER CODE END */
    osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
  }
  
}